import { MetadataBearer as $MetadataBearer, SmithyException as __SmithyException } from "@aws-sdk/types";

export interface AccessDeniedException extends __SmithyException, $MetadataBearer {
    name: "AccessDeniedException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace AccessDeniedException {
    
    const filterSensitiveLog: (obj: AccessDeniedException) => any;
}

export interface AuthorizationPendingException extends __SmithyException, $MetadataBearer {
    name: "AuthorizationPendingException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace AuthorizationPendingException {
    
    const filterSensitiveLog: (obj: AuthorizationPendingException) => any;
}
export interface CreateTokenRequest {
    
    clientId: string | undefined;
    
    clientSecret: string | undefined;
    
    grantType: string | undefined;
    
    deviceCode: string | undefined;
    
    code?: string;
    
    refreshToken?: string;
    
    scope?: string[];
    
    redirectUri?: string;
}
export declare namespace CreateTokenRequest {
    
    const filterSensitiveLog: (obj: CreateTokenRequest) => any;
}
export interface CreateTokenResponse {
    
    accessToken?: string;
    
    tokenType?: string;
    
    expiresIn?: number;
    
    refreshToken?: string;
    
    idToken?: string;
}
export declare namespace CreateTokenResponse {
    
    const filterSensitiveLog: (obj: CreateTokenResponse) => any;
}

export interface ExpiredTokenException extends __SmithyException, $MetadataBearer {
    name: "ExpiredTokenException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace ExpiredTokenException {
    
    const filterSensitiveLog: (obj: ExpiredTokenException) => any;
}

export interface InternalServerException extends __SmithyException, $MetadataBearer {
    name: "InternalServerException";
    $fault: "server";
    error?: string;
    error_description?: string;
}
export declare namespace InternalServerException {
    
    const filterSensitiveLog: (obj: InternalServerException) => any;
}

export interface InvalidClientException extends __SmithyException, $MetadataBearer {
    name: "InvalidClientException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace InvalidClientException {
    
    const filterSensitiveLog: (obj: InvalidClientException) => any;
}

export interface InvalidGrantException extends __SmithyException, $MetadataBearer {
    name: "InvalidGrantException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace InvalidGrantException {
    
    const filterSensitiveLog: (obj: InvalidGrantException) => any;
}

export interface InvalidRequestException extends __SmithyException, $MetadataBearer {
    name: "InvalidRequestException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace InvalidRequestException {
    
    const filterSensitiveLog: (obj: InvalidRequestException) => any;
}

export interface InvalidScopeException extends __SmithyException, $MetadataBearer {
    name: "InvalidScopeException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace InvalidScopeException {
    
    const filterSensitiveLog: (obj: InvalidScopeException) => any;
}

export interface SlowDownException extends __SmithyException, $MetadataBearer {
    name: "SlowDownException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace SlowDownException {
    
    const filterSensitiveLog: (obj: SlowDownException) => any;
}

export interface UnauthorizedClientException extends __SmithyException, $MetadataBearer {
    name: "UnauthorizedClientException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace UnauthorizedClientException {
    
    const filterSensitiveLog: (obj: UnauthorizedClientException) => any;
}

export interface UnsupportedGrantTypeException extends __SmithyException, $MetadataBearer {
    name: "UnsupportedGrantTypeException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace UnsupportedGrantTypeException {
    
    const filterSensitiveLog: (obj: UnsupportedGrantTypeException) => any;
}

export interface InvalidClientMetadataException extends __SmithyException, $MetadataBearer {
    name: "InvalidClientMetadataException";
    $fault: "client";
    error?: string;
    error_description?: string;
}
export declare namespace InvalidClientMetadataException {
    
    const filterSensitiveLog: (obj: InvalidClientMetadataException) => any;
}
export interface RegisterClientRequest {
    
    clientName: string | undefined;
    
    clientType: string | undefined;
    
    scopes?: string[];
}
export declare namespace RegisterClientRequest {
    
    const filterSensitiveLog: (obj: RegisterClientRequest) => any;
}
export interface RegisterClientResponse {
    
    clientId?: string;
    
    clientSecret?: string;
    
    clientIdIssuedAt?: number;
    
    clientSecretExpiresAt?: number;
    
    authorizationEndpoint?: string;
    
    tokenEndpoint?: string;
}
export declare namespace RegisterClientResponse {
    
    const filterSensitiveLog: (obj: RegisterClientResponse) => any;
}
export interface StartDeviceAuthorizationRequest {
    
    clientId: string | undefined;
    
    clientSecret: string | undefined;
    
    startUrl: string | undefined;
}
export declare namespace StartDeviceAuthorizationRequest {
    
    const filterSensitiveLog: (obj: StartDeviceAuthorizationRequest) => any;
}
export interface StartDeviceAuthorizationResponse {
    
    deviceCode?: string;
    
    userCode?: string;
    
    verificationUri?: string;
    
    verificationUriComplete?: string;
    
    expiresIn?: number;
    
    interval?: number;
}
export declare namespace StartDeviceAuthorizationResponse {
    
    const filterSensitiveLog: (obj: StartDeviceAuthorizationResponse) => any;
}
